<?php
if (!defined('_ECRIRE_INC_VERSION')) return;

/**
 * @param int $t
 * @return int
 */
function genie_caches_autoclean_dist (int $t): int {
	$unused = '';
	$cleaned = [];
	if (!function_exists('apcu_cache_info')) {
		return 1;
	}
	$cache_info = apcu_cache_info();
	foreach ( $cache_info['cache_list'] as $entry) {
		$key = $entry['info'];
		if ($key 
			and (strpos($key, _CACHE_NAMESPACE) === 0)
			and cache_est_perime($key, $unused, $entry)
		) {
			$cleaned[] = substr($key, strlen(_CACHE_NAMESPACE));
			apcu_delete($key);
		}
	}
	spip_log (($n=count($cleaned)) ? "$n caches périmés supprimés : ".implode(' ; ', $cleaned) : 'ZERO caches supprimés', 'caches_autoclean'._LOG_DEBUG);
	return 1;
}

if (!function_exists('cache_est_perime')) {
	// Signature moche requise par le cadre d'usage dans XRay... à revoir
	function cache_est_perime (string $nomcache, &$spip_cache_unused='', &$apcu_entry): bool {
		return (cache_est_perime_explic ($nomcache, $apcu_entry) != '');
	}
	function cache_est_perime_explic (string $nomcache, &$data=''): string {
		global $meta_derniere_modif;
		static $time = 0;
		$return = (!apcu_exists($nomcache) ? 'N’existe plus pour APCu' : '');
		$time = ($time ?: time());
		if ($data['ttl'] and ($data['creation_time'] + $data['ttl'] <= $time)) {
			if ($data['creation_time'] < $meta_derniere_modif) {
				return trim("$return + Périmé / APCu et SPIP", ' +');
			}
			return trim("$return + Périmé / APCu", ' +');
		}
		if ($data['creation_time'] <  $meta_derniere_modif) {
			return trim("$return + Périmé / SPIP", ' +');
		}
		return $return;
	}
}
